def stringxor(a, b):
    return ''.join(map(lambda x,y:chr(ord(x) ^ ord(y)),a,b))

def stringadd(a, b):
    return ''.join(map(lambda x,y:chr((ord(x) + ord(y))&0xff),a,b))

def update0(key0,key1,key2,key3,key4,key5,key6,key7,key8,key9,keya,keyb,keyc,keyd,keye,keyf,lastbyte):
    key0=key0 + lastbyte
    key3=key3+2 + lastbyte
    key4=key2+0x0b + lastbyte
    key8=key6+7
    return key0,key1,key2,key3,key4,key5,key6,key7,key8,key9,keya,keyb,keyc,keyd,keye,keyf

def update1(key0,key1,key2,key3,key4,key5,key6,key7,key8,key9,keya,keyb,keyc,keyd,keye,keyf,lastbyte):
    key6=key7+keyf
    key2=key9+keya
    key8=key8+key1
    keyf=key5+key3
    return key0,key1,key2,key3,key4,key5,key6,key7,key8,key9,keya,keyb,keyc,keyd,keye,keyf

def update2(key0,key1,key2,key3,key4,key5,key6,key7,key8,key9,keya,keyb,keyc,keyd,keye,keyf,lastbyte):
    key1 = key1+key2
    key7 = key7+key8
    key5 = key5+key6
    keya = keya+keyb
    return key0,key1,key2,key3,key4,key5,key6,key7,key8,key9,keya,keyb,keyc,keyd,keye,keyf

def update3(key0,key1,key2,key3,key4,key5,key6,key7,key8,key9,keya,keyb,keyc,keyd,keye,keyf,lastbyte):
    key9=key1+key2
    keyc=key8+key7
    keyb=key6+key5
    keyd=keya+key6+key5
    return key0,key1,key2,key3,key4,key5,key6,key7,key8,key9,keya,keyb,keyc,keyd,keye,keyf

def update4(key0,key1,key2,key3,key4,key5,key6,key7,key8,key9,keya,keyb,keyc,keyd,keye,keyf,lastbyte):
    key0=key1+0x6f
    key3=key4+0x47
    key4=key5+0x11
    keye=keyf+0x40
    return key0,key1,key2,key3,key4,key5,key6,key7,key8,key9,keya,keyb,keyc,keyd,keye,keyf

def update5(key0,key1,key2,key3,key4,key5,key6,key7,key8,key9,keya,keyb,keyc,keyd,keye,keyf,lastbyte):
    key2=keya+key2
    key4=keyc+key5
    key6=keye+key8
    key8=keyb+key0
    return key0,key1,key2,key3,key4,key5,key6,key7,key8,key9,keya,keyb,keyc,keyd,keye,keyf

def update6(key0,key1,key2,key3,key4,key5,key6,key7,key8,key9,keya,keyb,keyc,keyd,keye,keyf,lastbyte):
    key9=key1+keyb
    keyb=key3+keyd
    keyd=key5+keyf
    keyf=key7+key9
    return update7(key0,key1,key2,key3,key4,key5,key6,key7,key8,key9,keya,keyb,keyc,keyd,keye,keyf,lastbyte)

def update7(key0,key1,key2,key3,key4,key5,key6,key7,key8,key9,keya,keyb,keyc,keyd,keye,keyf,lastbyte):
    key1=key9+key5
    key2=keya+key6
    key3=keyb+key7
    key4=keyc+key8
    return key0,key1,key2,key3,key4,key5,key6,key7,key8,key9,keya,keyb,keyc,keyd,keye,keyf

updatefuns = [
    update0,
    update1,
    update2,
    update3,
    update4,
    update5,
    update6,
    update7,
]
    
def updatekey(key, lastchar):
    keyord = [ord(x) for x in key+lastchar]
    index = ord(lastchar) & 0x7
    keyord = updatefuns[index](*keyord)
    key = ''.join([chr(x&0xff) for x in keyord])
    return key

def decode(s):
    '''
    Decode a LastSong .dat file
    '''
    header = s[0:4]
    assert(header=='\x00\x00\x00\x01')
    key = s[4:20]
    out = ''
    rest = s[20:]
    while rest:
        # print len(rest)
        chunk = rest[0:16]
        rest = rest[16:]
        #print key.encode('hex')
        key = key[0:len(chunk)]
        out += stringxor(chunk,key)
        #print len(rest)
        if rest:
            key=updatekey(key,out[-2])
    return out

def encode(s, key='I like to sing!!'):
    '''
    Encode a LastSong .dat file
    '''
    out='\x00\x00\x00\x01'+key
    rest = s
    while rest:
        chunk = rest[0:16]
        rest = rest[16:]
        key = key[0:len(chunk)]
        out += stringxor(chunk,key)
        if rest:
            key=updatekey(key,chunk[-2])
    return out
